#include "tux.h"
#include "y.tab.h"
/*
#include <stdio.h>
#include <stdlib.h>
*/


static Symbol *symlist = 0; /* symbol table: linked list */

void   displayprog()
{
        Inst *p;
extern push();
	Inst ppush = &push;
extern Datum pop();
	Inst ppop = &pop;
extern varpush();
	Inst pvarpush = &varpush;
extern constpush();
	Inst pconstpush = &constpush;
extern eval();
	Inst peval = &eval;
extern assign();
	Inst passign = &assign;
extern bltin();
	Inst pbltin = &bltin;
	printf("function push      [%x]\n", ppush);
	printf("function pop       [%x]\n", ppop);
	printf("function varpush   [%x]\n", pvarpush);
	printf("function constpush [%x]\n", pconstpush);
	printf("function eval      [%x]\n", peval);
	printf("function assign    [%x]\n", passign);
	printf("function bltin     [%x]\n", pbltin);
	printf("+--------------prog-stack------------+\n");
        for ( p = prog; *p != STOP; ) {
                printf("intr /%x/ ", *p);
		if ( *p == ppush ) 
			printf("push");
		if ( *p == ppop ) 
			printf("pop");
		if ( *p == pvarpush ) 
			printf("varpush");
		if ( *p == pconstpush ) 
			printf("constpush");
		if ( *p == peval ) 
			printf("eval");
		if ( *p == passign ) 
			printf("assign");
		if ( *p == pbltin ) 
			printf("bltin");
		*p++;
		printf("\n");
	}
	printf("+------------------------------------+\n\n");
}
void   displaysym()
{
	Symbol *sp;
	printf("+--------------symtable------------+\n");
	for ( sp = symlist; sp != (Symbol *) 0; sp = sp->next ) {
		printf("> addr: [%x]\n", sp);
		if (sp->type == UNARYMINUS) {
			printf("  type: UNARYMINUS");
		} else if (sp->type == VAR) {
			printf("  type: VAR");
			printf("  name: /%s/ ", sp->name);
			printf("  val: /%f/ ", sp->u.val);
		} else if (sp->type == NUMBER) {
			printf("  type: NUMBER");
			printf("  val: /%f/ ", sp->u.val);
		} else if (sp->type == BLTIN) {
			printf("  type: BLTIN");
			printf("  name: /%s/ ", sp->name);
			printf("  function: /%x/", sp->u.ptr);
		} else if (sp->type == UNDEF) {
			printf("  type: UNDEF");
			printf("  name: /%s/ ", sp->name);
			printf("  val: /%f/ ", sp->u.val);
			printf("  function: /%x/", sp->u.ptr);
		} else {
			printf("  type: *error*");
		}
		printf("\n");
	}
	printf("+----------------------------------+\n\n");
}
Symbol   *lookupp( s )
	char *s;
{
	Symbol *sp;
	for ( sp = symlist; sp != (Symbol *) 0; sp = sp->next )
		if ( strcmp(sp->name, s) == 0 )
			return sp;
	return 0; /* not found */
}
Symbol *install( char *s, int t, double d )
{
	Symbol *sp;
	char *emalloc();
	sp = (Symbol *) emalloc(sizeof(Symbol));
	sp->name =  emalloc( strlen(s)+1 );
	strcpy(sp->name, s);
	sp->type = t;
	sp->u.val = d;
	sp->next = symlist; /* put at front of list */
	symlist = sp;
	return sp;
}
char *emalloc( unsigned n ) 
{
	char *p;
	p = malloc(n);
	if (p == 0)
		execerror("out of memory", (char *) 0);
	return p;
}
