typedef struct Symbol {  /* symbol table entry */
	char *name;
	short type;      /* var, bltin, undef */
	union {
		double val;         /* if var */
		double (*ptr)();    /* if bltin */
		int    (*defn)();   /* function, procedure */
		char   *str;	    /* STRING */
	} u;
	struct Symbol *next;
} Symbol;
Symbol *install(), *lookupp();
typedef union Datum { /* interpreter stack type */
	double val;
	Symbol *sym;
} Datum;
extern Datum pop();
extern int eval(), add(), sub(), mul(), divv(), negate(), power();
typedef Datum (*Inst)();	/* machine instruction */
#define STOP (Inst) 0


extern Inst prog[], *progp, *code(), *progbase ;
extern int assign(), bltin(), varpush(), constpush(), print(), varread();
extern prexpr(), prstr();
extern gt(), lt(), eq(), ge(), le(), ne(), and(), or(), not();
extern ifcode(), whilecode(), call(), arg(), argassign();
extern funcret(), procret();
int indef;
